function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["children", "id", "initialIsOpen", "initialValue", "onChange", "value"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useRef } from 'react';
import { useSelect } from 'downshift';
import { isNil } from 'lodash';
import { getSelectedItem, itemToString as _itemToString, SelectLayout } from '../SelectBase';
import { useExternalId } from '../../hooks/useExternalId';
import { useMenuVisibility } from '../SelectBase/hooks/useMenuVisibility';
import { useSelectMenu } from './hooks/useSelectMenu';
export var Select = function Select(_ref) {
  var children = _ref.children,
    externalId = _ref.id,
    initialIsOpen = _ref.initialIsOpen,
    initialValue = _ref.initialValue,
    onChange = _ref.onChange,
    value = _ref.value,
    rest = _objectWithoutProperties(_ref, _excluded);
  var id = useExternalId('select', externalId);
  var inputRef = useRef(null);
  var filteredItems = React.Children.toArray(children).filter(React.isValidElement);
  var items = filteredItems.map(function (child) {
    return child.props.value;
  });
  var itemsMap = Object.fromEntries(filteredItems.map(function (item) {
    return [item.props.value, item];
  }));
  var isControlled = value !== undefined;
  var _useSelect = useSelect(_objectSpread({
      itemToString: function itemToString(item) {
        return _itemToString(item, itemsMap);
      },
      initialIsOpen: initialIsOpen,
      items: items,
      onSelectedItemChange: function onSelectedItemChange(_ref2) {
        var newItem = _ref2.selectedItem;
        onChange === null || onChange === void 0 ? void 0 : onChange(newItem !== null && newItem !== void 0 ? newItem : null);
      }
    }, _defineProperty({}, isControlled ? 'selectedItem' : 'initialSelectedItem', getSelectedItem(isControlled ? value : initialValue, itemsMap)))),
    getItemProps = _useSelect.getItemProps,
    getMenuProps = _useSelect.getMenuProps,
    getToggleButtonProps = _useSelect.getToggleButtonProps,
    highlightedIndex = _useSelect.highlightedIndex,
    isOpen = _useSelect.isOpen,
    openMenu = _useSelect.openMenu,
    reset = _useSelect.reset,
    selectedItem = _useSelect.selectedItem;
  var _useMenuVisibility = useMenuVisibility(isOpen, openMenu),
    onInputFocusHandler = _useMenuVisibility.onInputFocusHandler;
  var _useSelectMenu = useSelectMenu(inputRef),
    onMenuKeyDownHandler = _useSelectMenu.onMenuKeyDownHandler;
  var selectedItemText = isNil(selectedItem) ? '' : itemsMap[selectedItem].props.children;
  return /*#__PURE__*/React.createElement(SelectLayout, _extends({
    hasSelectedItem: !isNil(selectedItem),
    id: id,
    inputProps: {
      onFocus: onInputFocusHandler,
      ref: inputRef
    },
    isOpen: isOpen,
    menuProps: getMenuProps({
      onKeyDown: onMenuKeyDownHandler
    }),
    onClearButtonClick: function onClearButtonClick() {
      reset();
    },
    toggleButtonProps: getToggleButtonProps(),
    tooltipText: selectedItemText,
    value: selectedItemText
  }, _objectSpread({
    readOnly: true
  }, rest)), isOpen && filteredItems.map(function (child, index) {
    return /*#__PURE__*/React.cloneElement(child, _objectSpread(_objectSpread(_objectSpread({}, child.props), getItemProps({
      index: index,
      disabled: child.props.isDisabled,
      item: child.props.value,
      key: "select-option-".concat(child.props.value)
    })), {}, {
      isHighlighted: highlightedIndex === index,
      title: child.props.children
    }));
  }));
};
Select.displayName = 'Select';